CREATE TABLE LAYER_OPENFLEX_RESOURCE_DEFINITIONS
(
    RESOURCE_NAME VARCHAR(48) NOT NULL,
    SNAPSHOT_NAME VARCHAR(48) NOT NULL DEFAULT '', -- snapshots are not supported currently. column needed for FK
    RESOURCE_NAME_SUFFIX VARCHAR(48) NOT NULL,
    -- NvmeSpec 7.9: NQN: UTF-8, max 223 BYTES, null terminated
    NQN VARCHAR(230), -- nullable
    CONSTRAINT PK_LOFRD PRIMARY KEY (RESOURCE_NAME, RESOURCE_NAME_SUFFIX),
    CONSTRAINT FK_LOFRD_RD FOREIGN KEY (RESOURCE_NAME, SNAPSHOT_NAME) REFERENCES RESOURCE_DEFINITIONS(RESOURCE_NAME, SNAPSHOT_NAME)
);

CREATE TABLE LAYER_OPENFLEX_VOLUMES
(
    LAYER_RESOURCE_ID INTEGER NOT NULL,
    VLM_NR INTEGER NOT NULL,
    NODE_NAME VARCHAR(255), -- nullable for initiator
    POOL_NAME VARCHAR(48), -- nullable for initiator
    CONSTRAINT PK_LOFV PRIMARY KEY (LAYER_RESOURCE_ID, VLM_NR),
    CONSTRAINT FK_LOFV_LRI FOREIGN KEY (LAYER_RESOURCE_ID) REFERENCES LAYER_RESOURCE_IDS(LAYER_RESOURCE_ID),
    CONSTRAINT FK_LOFV_NSP FOREIGN KEY (NODE_NAME, POOL_NAME) REFERENCES NODE_STOR_POOL(NODE_NAME, POOL_NAME)
);
