/*
 * This file was autogenerated by genproperties.py
 *
 * LINSTOR - management of distributed storage/DRBD9 resources
 * Copyright (C) 2017 - 2021  LINBIT HA-Solutions GmbH
 * Author: Rene Peinthor, Gabor Hernadi
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.linbit.linstor.api.prop;

import com.linbit.linstor.api.prop.LinStorObject;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

public final class GeneratedPropertyRules
{
    public static List<Property> getWhitelistedProperties()
    {
        List<Property> propertyList = new ArrayList<>();
        propertyList.add(
            new PropertyBuilder()
                .name("after-resync-target")
                .internal("True")
                .keyStr("DrbdOptions/Handlers/after-resync-target")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("after-sb-0pri")
                .internal("True")
                .keyStr("DrbdOptions/Net/after-sb-0pri")
                .type("symbol")
                .values(
                    "discard-least-changes",
                    "discard-local",
                    "discard-older-primary",
                    "discard-remote",
                    "discard-younger-primary",
                    "discard-zero-changes",
                    "disconnect"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("after-sb-1pri")
                .internal("True")
                .keyStr("DrbdOptions/Net/after-sb-1pri")
                .type("symbol")
                .values(
                    "call-pri-lost-after-sb",
                    "consensus",
                    "discard-secondary",
                    "disconnect",
                    "violently-as0p"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("after-sb-2pri")
                .internal("True")
                .keyStr("DrbdOptions/Net/after-sb-2pri")
                .type("symbol")
                .values(
                    "call-pri-lost-after-sb",
                    "disconnect",
                    "violently-as0p"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("al-extents")
                .dflt("1237")
                .internal("True")
                .keyStr("DrbdOptions/Disk/al-extents")
                .max("65534")
                .min("67")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("al-updates")
                .dflt("True")
                .internal("True")
                .keyStr("DrbdOptions/Disk/al-updates")
                .type("boolean")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("allow-remote-read")
                .dflt("True")
                .internal("True")
                .keyStr("DrbdOptions/Net/allow-remote-read")
                .type("boolean")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("allow-two-primaries")
                .dflt("False")
                .internal("True")
                .keyStr("DrbdOptions/Net/allow-two-primaries")
                .type("boolean")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("always-asbp")
                .dflt("False")
                .internal("True")
                .keyStr("DrbdOptions/Net/always-asbp")
                .type("boolean")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("auto-promote")
                .dflt("True")
                .internal("True")
                .keyStr("DrbdOptions/Resource/auto-promote")
                .type("boolean")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("auto-promote-timeout")
                .dflt("20")
                .internal("True")
                .keyStr("DrbdOptions/Resource/auto-promote-timeout")
                .max("600")
                .min("0")
                .type("range")
                .unit("1/10 seconds")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("auto_evict_after_time")
                .dflt("60")
                .info("Time a node can be offline before it is declared EVICTED in minutes")
                .internal("False")
                .keyRef("NAMESPC_DRBD_OPTIONS", "KEY_AUTO_EVICT_AFTER_TIME")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("auto_evict_allow_eviction")
                .dflt("true")
                .info("If set to true on a node, it cannot be evicted anymore")
                .internal("False")
                .keyRef("NAMESPC_DRBD_OPTIONS", "KEY_AUTO_EVICT_ALLOW_EVICTION")
                .type("boolean_true_false")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("auto_evict_max_disconnected_nodes")
                .dflt("34")
                .info("Percentage(0-100) of nodes that can disconnect at the same time without the controller stopping the max_offline_time timer")
                .internal("False")
                .keyRef("NAMESPC_DRBD_OPTIONS", "KEY_AUTO_EVICT_MAX_DISCONNECTED_NODES")
                .max("100")
                .min("0")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("auto_evict_min_replica_count")
                .dflt("The place count set for the resource group")
                .info("The minimum amount of replicas that should be present for a resource at all times.")
                .internal("False")
                .keyRef("NAMESPC_DRBD_OPTIONS", "KEY_AUTO_EVICT_MIN_REPLICA_COUNT")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("auto_snapshot_keep")
                .dflt("10")
                .info("Keeps the last X auto-snapshots. Removing this property or having a value <= 0 disables auto-cleanup, all auto-snapshots will be kept")
                .keyRef("NAMESPC_AUTO_SNAPSHOT", "KEY_KEEP")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("auto_snapshot_next_id")
                .info("The next ID to try for auto-snapshots")
                .keyRef("NAMESPC_AUTO_SNAPSHOT", "KEY_AUTO_SNAPSHOT_NEXT_ID")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("auto_snapshot_run_every")
                .info("Runs every X minutes an snapshot-creation. Removing this property or having a value <= 0 disables auto-snapshotting.")
                .keyRef("NAMESPC_AUTO_SNAPSHOT", "KEY_RUN_EVERY")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("autoplacer_max_throughput")
                .info("The maximum throughput the given storage pool is capable of.")
                .keyRef("NAMESPC_AUTOPLACER", "KEY_AUTOPLACE_MAX_THROUGHPUT")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("autoplacer_pre_select_script_filename")
                .info("Filename of the preselection script. File must be in /etc/linstor/selector/")
                .keyRef("NAMESPC_AUTOPLACER", "KEY_AUTOPLACE_PRE_SELECT_FILE_NAME")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("autoplacer_pre_select_script_timeout")
                .dflt("5000")
                .info("Timeout in ms Linstor waits for the script to run.")
                .keyRef("NAMESPC_AUTOPLACER", "KEY_AUTOPLACE_PRE_SELECT_SCRIPT_TIMEOUT")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("autoplacer_strat_weights_max_freespace")
                .dflt("1.0")
                .info("Weight of 'MaxFreeSpace' autoplacer-strategy")
                .keyRef("NAMESPC_AUTOPLACER_WEIGHTS", "KEY_AUTOPLACE_STRAT_WEIGHT_MAX_FREESPACE")
                .type("regex")
                .value("^[0-9]+([.][0-9]+)?")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("autoplacer_strat_weights_max_throughput")
                .dflt("0.0")
                .info("Weight of 'MaxThroughput' autoplacer-strategy")
                .keyRef("NAMESPC_AUTOPLACER_WEIGHTS", "KEY_AUTOPLACE_MAX_THROUGHPUT")
                .type("regex")
                .value("^[0-9]+([.][0-9]+)?")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("autoplacer_strat_weights_min_reserved_space")
                .dflt("0.0")
                .info("Weight of 'MinReservedSpace' autoplacer-strategy")
                .keyRef("NAMESPC_AUTOPLACER_WEIGHTS", "KEY_AUTOPLACE_STRAT_WEIGHT_MIN_RESERVED_SPACE")
                .type("regex")
                .value("^[0-9]+([.][0-9]+)?")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("autoplacer_strat_weights_min_rsc_count")
                .dflt("0.0")
                .info("Weight of 'MinRscCount' autoplacer-strategy")
                .keyRef("NAMESPC_AUTOPLACER_WEIGHTS", "KEY_AUTOPLACE_STRAT_WEIGHT_MIN_RSC_COUNT")
                .type("regex")
                .value("^[0-9]+([.][0-9]+)?")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("backup_shipping_s3_key_suffix")
                .dflt("")
                .info("A suffix to be appended in order to distiguish same backup names from different Linstor clusters")
                .keyRef("NAMESPC_BACKUP_SHIPPING", "KEY_BACKUP_S3_SUFFIX")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("backup_shipping_timeout")
                .dflt("5")
                .info("The timeout in seconds to be used for API-requests during backup list and backup delete")
                .keyRef("NAMESPC_BACKUP_SHIPPING", "KEY_BACKUP_TIMEOUT")
                .type("long")
                .unit("seconds")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("bcache_block_size")
                .info("Block size")
                .keyRef("NAMESPC_BCACHE", "KEY_BCACHE_BLOCKSIZE")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("bcache_bucket_size")
                .info("Bucket size")
                .keyRef("NAMESPC_BCACHE", "KEY_BCACHE_BUCKETSIZE")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("bcache_cache_replacement_policy")
                .info("Cache replacement policy. Default: lru")
                .keyRef("NAMESPC_BCACHE", "KEY_BCACHE_CACHE_REPLACEMENT_POLICY")
                .type("symbol")
                .values(
                    "fifo",
                    "lru"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("bcache_data_offset")
                .info("Data offset")
                .keyRef("NAMESPC_BCACHE", "KEY_BCACHE_DATA_OFFSET")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("bcache_discard")
                .info("Enable discard if set to true")
                .keyRef("NAMESPC_BCACHE", "KEY_BCACHE_DISCARD")
                .type("boolean_true_false")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("bcache_pool")
                .info("Name of the storage pool used for the bcache")
                .keyRef("NAMESPC_BCACHE", "KEY_BCACHE_POOL_NAME")
                .type("regex")
                .value("^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("bcache_size")
                .dflt("5%")
                .info("Size of the cache in % (0-100) or KiB otherwise. Minimum 524288")
                .keyRef("NAMESPC_BCACHE", "KEY_BCACHE_SIZE")
                .type("regex")
                .value("^100%|[0-9]{1,2}([.][0-9]*)?%|[1-9][0-9]{2,}$")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("bcache_writeback")
                .info("Enable writeback if set to true")
                .keyRef("NAMESPC_BCACHE", "KEY_BCACHE_WRITEBACK")
                .type("boolean_true_false")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("before-resync-source")
                .internal("True")
                .keyStr("DrbdOptions/Handlers/before-resync-source")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("before-resync-target")
                .internal("True")
                .keyStr("DrbdOptions/Handlers/before-resync-target")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("bitmap")
                .dflt("True")
                .internal("True")
                .keyStr("DrbdOptions/PeerDevice/bitmap")
                .type("boolean")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("c-delay-target")
                .dflt("10")
                .internal("True")
                .keyStr("DrbdOptions/PeerDevice/c-delay-target")
                .max("100")
                .min("1")
                .type("range")
                .unit("1/10 seconds")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("c-fill-target")
                .dflt("100")
                .internal("True")
                .keyStr("DrbdOptions/PeerDevice/c-fill-target")
                .max("1048576")
                .min("0")
                .type("range")
                .unit("bytes")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("c-max-rate")
                .dflt("102400")
                .internal("True")
                .keyStr("DrbdOptions/PeerDevice/c-max-rate")
                .max("4194304")
                .min("0")
                .type("range")
                .unit("bytes/second")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("c-min-rate")
                .dflt("250")
                .internal("True")
                .keyStr("DrbdOptions/PeerDevice/c-min-rate")
                .max("4194304")
                .min("0")
                .type("range")
                .unit("bytes/second")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("c-plan-ahead")
                .dflt("20")
                .internal("True")
                .keyStr("DrbdOptions/PeerDevice/c-plan-ahead")
                .max("300")
                .min("0")
                .type("range")
                .unit("1/10 seconds")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("cache_blocksize")
                .dflt("4096")
                .info("Block size")
                .keyRef("NAMESPC_CACHE", "KEY_CACHE_BLOCK_SIZE")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("cache_cache_pool")
                .info("Name of the storage pool used for the cache cache device")
                .keyRef("NAMESPC_CACHE", "KEY_CACHE_CACHE_POOL_NAME")
                .type("regex")
                .value("^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("cache_cache_size")
                .dflt("5%")
                .info("Size of the cache in % (0-100) or KiB otherwise.")
                .keyRef("NAMESPC_CACHE", "KEY_CACHE_CACHE_SIZE")
                .type("regex")
                .value("^100%|[0-9]{1,2}([.][0-9]*)?%|[1-9][0-9]{2,}$")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("cache_meta_pool")
                .info("Name of the storage pool used for the cache metadata. If not specified, this will default to the CachePool property")
                .keyRef("NAMESPC_CACHE", "KEY_CACHE_META_POOL_NAME")
                .type("regex")
                .value("^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("cache_meta_size")
                .dflt("12288")
                .info("Size of the cache in % (0-100) or KiB otherwise.")
                .keyRef("NAMESPC_CACHE", "KEY_CACHE_META_SIZE")
                .type("regex")
                .value("^100%|[0-9]{1,2}([.][0-9]*)?%|[1-9][0-9]{2,}$")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("cache_op_mode")
                .dflt("writethrough")
                .info("Operation mode")
                .keyRef("NAMESPC_CACHE", "KEY_CACHE_OPERATING_MODE")
                .type("symbol")
                .values(
                    "passthrough",
                    "writeback",
                    "writethrough"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("cache_policy")
                .dflt("smq")
                .info("Replacement policy")
                .keyRef("NAMESPC_CACHE", "KEY_CACHE_POLICY")
                .type("symbol")
                .values(
                    "cleaner",
                    "mq",
                    "smq"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("congestion-extents")
                .dflt("1237")
                .internal("True")
                .keyStr("DrbdOptions/Net/congestion-extents")
                .max("65534")
                .min("67")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("congestion-fill")
                .dflt("0")
                .internal("True")
                .keyStr("DrbdOptions/Net/congestion-fill")
                .max("20971520")
                .min("0")
                .type("range")
                .unit("bytes")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("connect-int")
                .dflt("10")
                .internal("True")
                .keyStr("DrbdOptions/Net/connect-int")
                .max("120")
                .min("1")
                .type("range")
                .unit("seconds")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("cpu-mask")
                .internal("True")
                .keyStr("DrbdOptions/Resource/cpu-mask")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("cram-hmac-alg")
                .internal("True")
                .keyStr("DrbdOptions/Net/cram-hmac-alg")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("csums-after-crash-only")
                .dflt("False")
                .internal("True")
                .keyStr("DrbdOptions/Net/csums-after-crash-only")
                .type("boolean")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("csums-alg")
                .internal("True")
                .keyStr("DrbdOptions/Net/csums-alg")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("data-integrity-alg")
                .internal("True")
                .keyStr("DrbdOptions/Net/data-integrity-alg")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("disable-write-same")
                .dflt("False")
                .internal("True")
                .keyStr("DrbdOptions/Disk/disable-write-same")
                .type("boolean")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("discard-zeroes-if-aligned")
                .dflt("True")
                .internal("True")
                .keyStr("DrbdOptions/Disk/discard-zeroes-if-aligned")
                .type("boolean")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("disk-barrier")
                .dflt("False")
                .internal("True")
                .keyStr("DrbdOptions/Disk/disk-barrier")
                .type("boolean")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("disk-drain")
                .dflt("True")
                .internal("True")
                .keyStr("DrbdOptions/Disk/disk-drain")
                .type("boolean")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("disk-flushes")
                .dflt("True")
                .internal("True")
                .keyStr("DrbdOptions/Disk/disk-flushes")
                .type("boolean")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("disk-timeout")
                .dflt("0")
                .internal("True")
                .keyStr("DrbdOptions/Disk/disk-timeout")
                .max("6000")
                .min("0")
                .type("range")
                .unit("1/10 seconds")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("dm_stats")
                .info("Enable dmstats on lvm create")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_DMSTATS")
                .type("boolean_true_false")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("drbd_auto_add_quorum_tie_breaker")
                .info("Enables automatic management (creation and deletion) of tie breaking resource")
                .internal("False")
                .keyRef("NAMESPC_DRBD_OPTIONS", "KEY_DRBD_AUTO_ADD_QUORUM_TIEBREAKER")
                .type("boolean_true_false")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("drbd_auto_diskful")
                .info("Makes a resource diskful if it was continuously diskless primary for X minutes")
                .internal("False")
                .keyRef("NAMESPC_DRBD_OPTIONS", "KEY_DRBD_AUTO_DISKFUL")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("drbd_auto_diskful_allow_cleanup")
                .info("Allows this resource to be cleaned up after toggle-disk + resync is finished")
                .internal("False")
                .keyRef("NAMESPC_DRBD_OPTIONS", "KEY_DRBD_AUTO_DISKFUL_ALLOW_CLEANUP")
                .type("boolean_true_false")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("drbd_auto_quorum")
                .info("Enables automatic setting of the 'quorum' and 'on-no-quorum' property")
                .internal("False")
                .keyRef("NAMESPC_DRBD_OPTIONS", "KEY_DRBD_AUTO_QUORUM")
                .type("symbol")
                .values(
                    "disabled",
                    "io-error",
                    "suspend-io"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("drbd_auto_verify_algo_allowed_user")
                .info("A list of verify algorithms allowed by user, semicolon separated")
                .internal("False")
                .keyRef("NAMESPC_DRBD_OPTIONS", "KEY_DRBD_AUTO_VERIFY_ALGO_ALLOWED_USER")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("drbd_auto_verify_algo_disable")
                .info("If set to true it will disable automatic setting of DRBD verify algorithm")
                .internal("False")
                .keyRef("NAMESPC_DRBD_OPTIONS", "KEY_DRBD_DISABLE_AUTO_VERIFY_ALGO")
                .type("boolean_true_false")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("drbd_current_gi")
                .info("Initial DRBD generation id, if initial sync is skipped, this ID will be set")
                .internal("False")
                .keyRef("KEY_DRBD_CURRENT_GI")
                .type("regex")
                .value("[a-fA-F0-9]{16}")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("ext_cmd_wait_to")
                .info("Wait timeout for an external command in milliseconds")
                .internal("False")
                .keyRef("KEY_EXT_CMD_WAIT_TO")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("fence-peer")
                .internal("True")
                .keyStr("DrbdOptions/Handlers/fence-peer")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("fencing")
                .internal("True")
                .keyStr("DrbdOptions/Net/fencing")
                .type("symbol")
                .values(
                    "dont-care",
                    "resource-and-stonith",
                    "resource-only"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("fs_mkfsparameters")
                .info("Additional parameters for the mkfs command")
                .internal("False")
                .keyRef("NAMESPC_FILESYSTEM", "KEY_FS_MKFSPARAMETERS")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("fs_type")
                .info("File system type to use")
                .internal("False")
                .keyRef("NAMESPC_FILESYSTEM", "KEY_FS_TYPE")
                .type("symbol")
                .values(
                    "ext4",
                    "xfs"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("initial-split-brain")
                .internal("True")
                .keyStr("DrbdOptions/Handlers/initial-split-brain")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("ko-count")
                .dflt("7")
                .internal("True")
                .keyStr("DrbdOptions/Net/ko-count")
                .max("200")
                .min("0")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("local-io-error")
                .internal("True")
                .keyStr("DrbdOptions/Handlers/local-io-error")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("max-buffers")
                .dflt("2048")
                .internal("True")
                .keyStr("DrbdOptions/Net/max-buffers")
                .max("131072")
                .min("32")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("max-epoch-size")
                .dflt("2048")
                .internal("True")
                .keyStr("DrbdOptions/Net/max-epoch-size")
                .max("20000")
                .min("1")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("max-io-depth")
                .dflt("8000")
                .internal("True")
                .keyStr("DrbdOptions/Resource/max-io-depth")
                .max("4294967295")
                .min("4")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("max_oversubscription_ratio")
                .info("Maximum allowed ratio of the sum of volume sizes in a thin pool to the total capacity of the pool (default 20)")
                .keyRef("KEY_STOR_POOL_DFN_MAX_OVERSUBSCRIPTION_RATIO")
                .max("1000")
                .min("1")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("md-flushes")
                .dflt("True")
                .internal("True")
                .keyStr("DrbdOptions/Disk/md-flushes")
                .type("boolean")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("minor_nr_range")
                .info("Range for auto-allocation of volume minor numbers")
                .keyRef("KEY_MINOR_NR_AUTO_RANGE")
                .type("regex")
                .value("[0-9]+-[0-9]+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("nvme_port")
                .info("NVMe port")
                .internal("False")
                .keyRef("NAMESPC_NVME", "KEY_PORT")
                .max("65535")
                .min("1")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("nvme_preferred_nic")
                .info("Preferred network interface to use")
                .internal("False")
                .keyRef("NAMESPC_NVME", "KEY_PREF_NIC")
                .type("regex")
                .value("^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("nvme_tr_type")
                .dflt("rdma")
                .info("NVMe transportation type")
                .internal("False")
                .keyRef("NAMESPC_NVME", "KEY_TR_TYPE")
                .type("symbol")
                .values(
                    "rdma",
                    "tcp"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("on-congestion")
                .internal("True")
                .keyStr("DrbdOptions/Net/on-congestion")
                .type("symbol")
                .values(
                    "block",
                    "disconnect",
                    "pull-ahead"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("on-io-error")
                .internal("True")
                .keyStr("DrbdOptions/Disk/on-io-error")
                .type("symbol")
                .values(
                    "call-local-io-error",
                    "detach",
                    "pass_on"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("on-no-data-accessible")
                .internal("True")
                .keyStr("DrbdOptions/Resource/on-no-data-accessible")
                .type("symbol")
                .values(
                    "io-error",
                    "suspend-io"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("on-no-quorum")
                .internal("True")
                .keyStr("DrbdOptions/Resource/on-no-quorum")
                .type("symbol")
                .values(
                    "io-error",
                    "suspend-io"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("out-of-sync")
                .internal("True")
                .keyStr("DrbdOptions/Handlers/out-of-sync")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("override_vlm_id")
                .info("Overwrites the generated '<resource-name>_<5 digit volume number>' volume name for migration purposes")
                .keyRef("KEY_STOR_POOL_OVERRIDE_VLM_ID")
                .type("regex")
                .value(".*")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("peer-ack-delay")
                .dflt("100")
                .internal("True")
                .keyStr("DrbdOptions/Resource/peer-ack-delay")
                .max("10000")
                .min("1")
                .type("range")
                .unit("milliseconds")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("peer-ack-window")
                .dflt("4096")
                .internal("True")
                .keyStr("DrbdOptions/Resource/peer-ack-window")
                .max("204800")
                .min("2048")
                .type("range")
                .unit("bytes")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("peer_slots")
                .info("DRBD peer slots present on resource")
                .internal("True")
                .keyRef("KEY_PEER_SLOTS")
                .max("31")
                .min("1")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("peer_slots_new_resource")
                .info("DRBD peer slots to allocate for newly created resources (default 7), the number of peer slots cannot be changed once the resource is created, so allow sufficient slots to increase redundancy in the future")
                .keyRef("KEY_PEER_SLOTS_NEW_RESOURCE")
                .max("31")
                .min("1")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("ping-int")
                .dflt("10")
                .internal("True")
                .keyStr("DrbdOptions/Net/ping-int")
                .max("120")
                .min("1")
                .type("range")
                .unit("seconds")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("ping-timeout")
                .dflt("5")
                .internal("True")
                .keyStr("DrbdOptions/Net/ping-timeout")
                .max("300")
                .min("1")
                .type("range")
                .unit("1/10 seconds")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("preferred_nic")
                .info("Preferred network interface to use")
                .keyRef("KEY_STOR_POOL_PREF_NIC")
                .type("regex")
                .value("^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("pri-lost")
                .internal("True")
                .keyStr("DrbdOptions/Handlers/pri-lost")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("pri-lost-after-sb")
                .internal("True")
                .keyStr("DrbdOptions/Handlers/pri-lost-after-sb")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("pri-on-incon-degr")
                .internal("True")
                .keyStr("DrbdOptions/Handlers/pri-on-incon-degr")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("protocol")
                .internal("True")
                .keyStr("DrbdOptions/Net/protocol")
                .type("symbol")
                .values(
                    "A",
                    "B",
                    "C"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("proxy_auto_enable")
                .dflt("false")
                .internal("True")
                .keyRef("NAMESPC_DRBD_PROXY", "KEY_DRBD_PROXY_AUTO_ENABLE")
                .type("boolean_true_false")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("proxy_compression_lzma_contexts")
                .dflt("thread count")
                .internal("True")
                .keyStr("DrbdOptions/ProxyCompression/contexts")
                .max("253")
                .min("1")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("proxy_compression_lzma_depth")
                .dflt("0")
                .internal("True")
                .keyStr("DrbdOptions/ProxyCompression/depth")
                .max("1000")
                .min("0")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("proxy_compression_lzma_dict_size")
                .dflt("32768")
                .internal("True")
                .keyStr("DrbdOptions/ProxyCompression/dict-size")
                .max("1610612736")
                .min("4096")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("proxy_compression_lzma_fallback_to_zlib")
                .dflt("off")
                .internal("True")
                .keyStr("DrbdOptions/ProxyCompression/fallback-to-zlib")
                .type("symbol")
                .values(
                    "off",
                    "on"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("proxy_compression_lzma_lc")
                .dflt("3")
                .internal("True")
                .keyStr("DrbdOptions/ProxyCompression/lc")
                .max("4")
                .min("0")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("proxy_compression_lzma_level")
                .dflt("4")
                .internal("True")
                .keyStr("DrbdOptions/ProxyCompression/level")
                .max("9")
                .min("1")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("proxy_compression_lzma_lp")
                .dflt("0")
                .internal("True")
                .keyStr("DrbdOptions/ProxyCompression/lp")
                .max("4")
                .min("0")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("proxy_compression_lzma_mf")
                .dflt("hc3")
                .internal("True")
                .keyStr("DrbdOptions/ProxyCompression/mf")
                .type("symbol")
                .values(
                    "bt2",
                    "bt3",
                    "bt4",
                    "hc3",
                    "hc4"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("proxy_compression_lzma_mode")
                .dflt("fast")
                .internal("True")
                .keyStr("DrbdOptions/ProxyCompression/mode")
                .type("symbol")
                .values(
                    "fast",
                    "normal"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("proxy_compression_lzma_nice_len")
                .dflt("273")
                .internal("True")
                .keyStr("DrbdOptions/ProxyCompression/nice-len")
                .max("273")
                .min("0")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("proxy_compression_lzma_numa_threshold")
                .dflt("0")
                .internal("True")
                .keyStr("DrbdOptions/ProxyCompression/numa-threshold")
                .max("253")
                .min("0")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("proxy_compression_lzma_pb")
                .dflt("2")
                .internal("True")
                .keyStr("DrbdOptions/ProxyCompression/pb")
                .max("4")
                .min("0")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("proxy_compression_type")
                .internal("True")
                .keyRef("NAMESPC_DRBD_PROXY", "KEY_DRBD_PROXY_COMPRESSION_TYPE")
                .type("symbol")
                .values(
                    "lz4",
                    "lzma",
                    "zlib",
                    "zstd"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("proxy_compression_zlib_level")
                .dflt("2")
                .internal("True")
                .keyStr("DrbdOptions/ProxyCompression/level")
                .max("9")
                .min("1")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("proxy_compression_zstd_level")
                .dflt("3")
                .internal("True")
                .keyStr("DrbdOptions/ProxyCompression/level")
                .max("22")
                .min("1")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("proxy_memlimit")
                .dflt("16777216")
                .internal("True")
                .keyStr("DrbdOptions/Proxy/memlimit")
                .max("9223372036854775807")
                .min("16777216")
                .type("range")
                .unit("bytes")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("proxy_ping_timeout")
                .dflt("200")
                .internal("True")
                .keyStr("DrbdOptions/Proxy/ping-timeout")
                .max("300")
                .min("1")
                .type("range")
                .unit("1/10 seconds")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("proxy_rcvbuf_size")
                .dflt("0")
                .internal("True")
                .keyStr("DrbdOptions/Proxy/rcvbuf-size")
                .max("10485760")
                .min("0")
                .type("range")
                .unit("bytes")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("proxy_read_loops")
                .dflt("0")
                .internal("True")
                .keyStr("DrbdOptions/Proxy/read-loops")
                .max("2147483647")
                .min("0")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("proxy_sndbuf_size")
                .dflt("0")
                .internal("True")
                .keyStr("DrbdOptions/Proxy/sndbuf-size")
                .max("10485760")
                .min("0")
                .type("range")
                .unit("bytes")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("quorum")
                .internal("True")
                .keyStr("DrbdOptions/Resource/quorum")
                .max("32")
                .min("1")
                .type("numeric-or-symbol")
                .values(
                    "all",
                    "majority",
                    "off"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("quorum-lost")
                .internal("True")
                .keyStr("DrbdOptions/Handlers/quorum-lost")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("quorum-minimum-redundancy")
                .internal("True")
                .keyStr("DrbdOptions/Resource/quorum-minimum-redundancy")
                .max("32")
                .min("1")
                .type("numeric-or-symbol")
                .values(
                    "all",
                    "majority",
                    "off"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("rcvbuf-size")
                .dflt("0")
                .internal("True")
                .keyStr("DrbdOptions/Net/rcvbuf-size")
                .max("10485760")
                .min("0")
                .type("range")
                .unit("bytes")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("read-balancing")
                .internal("True")
                .keyStr("DrbdOptions/Disk/read-balancing")
                .type("symbol")
                .values(
                    "128K-striping",
                    "1M-striping",
                    "256K-striping",
                    "32K-striping",
                    "512K-striping",
                    "64K-striping",
                    "least-pending",
                    "prefer-local",
                    "prefer-remote",
                    "round-robin",
                    "when-congested-remote"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("rest_disable_http_metrics")
                .info("Disable Prometheus /metrics on HTTP, if HTTPS is enabled")
                .internal("False")
                .keyRef("NAMESPC_REST", "KEY_DISABLE_HTTP_METRICS")
                .type("boolean_true_false")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("resync-after")
                .internal("True")
                .keyStr("DrbdOptions/Disk/resync-after")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("resync-rate")
                .dflt("250")
                .internal("True")
                .keyStr("DrbdOptions/PeerDevice/resync-rate")
                .max("8388608")
                .min("1")
                .type("range")
                .unit("bytes/second")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("rr-conflict")
                .internal("True")
                .keyStr("DrbdOptions/Net/rr-conflict")
                .type("symbol")
                .values(
                    "call-pri-lost",
                    "disconnect",
                    "retry-connect",
                    "violently"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("rs-discard-granularity")
                .dflt("0")
                .internal("True")
                .keyStr("DrbdOptions/Disk/rs-discard-granularity")
                .max("1048576")
                .min("0")
                .type("range")
                .unit("bytes")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("search_domain")
                .info("Search domain node names, if no FQDN is given.")
                .internal("False")
                .keyRef("KEY_SEARCH_DOMAIN")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("shared-secret")
                .internal("True")
                .keyStr("DrbdOptions/Net/shared-secret")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("site")
                .internal("True")
                .keyRef("KEY_SITE")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("snapshot_shipping_keep")
                .dflt("10")
                .info("Keeps the last X sihpped snapshots. Removing this property or having a value <= 0 disables auto-cleanup, all auto-snapshots will be kept")
                .keyRef("NAMESPC_SNAPSHOT_SHIPPING", "KEY_KEEP")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("snapshot_shipping_port_range")
                .info("Range for allocation of snapshot shipping TCP ports")
                .keyRef("NAMESPC_SNAPSHOT_SHIPPING", "KEY_TCP_PORT_RANGE")
                .type("regex")
                .value("[0-9]+-[0-9]+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("snapshot_shipping_run_every")
                .info("Runs every X minutes an auto-snapshot-shipping unless the current snapshot-shipping is still running. In this case a new one will be started asap.")
                .keyRef("NAMESPC_SNAPSHOT_SHIPPING", "KEY_RUN_EVERY")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("snapshot_shipping_source")
                .info("Node name of the snapshot shipping source")
                .keyRef("NAMESPC_SNAPSHOT_SHIPPING", "KEY_SOURCE_NODE")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("snapshot_shipping_target")
                .info("Node name of the snapshot shipping target")
                .keyRef("NAMESPC_SNAPSHOT_SHIPPING", "KEY_TARGET_NODE")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("sndbuf-size")
                .dflt("0")
                .internal("True")
                .keyStr("DrbdOptions/Net/sndbuf-size")
                .max("10485760")
                .min("0")
                .type("range")
                .unit("bytes")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("socket-check-timeout")
                .dflt("0")
                .internal("True")
                .keyStr("DrbdOptions/Net/socket-check-timeout")
                .max("300")
                .min("0")
                .type("range")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("split-brain")
                .internal("True")
                .keyStr("DrbdOptions/Handlers/split-brain")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("storage_pool_drbd_meta_name")
                .info("Linstor storage pool name to use for external metadata.")
                .keyRef("KEY_STOR_POOL_DRBD_META_NAME")
                .type("regex")
                .value("^|.internal|[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("storage_pool_exos_create_vlm_options")
                .info("Any additional parameters appended to /create/volume/pool/${poolName}/size/${size}KiB/${vlmName}")
                .keyRef("NAMESPC_EXOS", "KEY_STOR_POOL_EXOS_CREATE_VOLUME_OPTIONS")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("storage_pool_exos_enclosure")
                .info("Name of the Exos enclosure")
                .keyRef("NAMESPC_EXOS", "KEY_STOR_POOL_EXOS_ENCLOSURE")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("storage_pool_exos_pool_sn")
                .info("Serial number of the Exos pool")
                .keyRef("NAMESPC_EXOS", "KEY_STOR_POOL_EXOS_POOL_SN")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("storage_pool_exos_vlm_type")
                .info("linear: Volumes are created from Disk Groups (vdisks), virtual: Volumes are created from Pools which is a set of Disk Groups (vdisks)")
                .keyRef("NAMESPC_EXOS", "KEY_STOR_POOL_EXOS_VLM_TYPE")
                .type("symbol")
                .values(
                    "linear",
                    "virtual"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("storage_pool_name")
                .info("Linstor storage pool name to use.")
                .keyRef("KEY_STOR_POOL_NAME")
                .type("regex")
                .value("^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("storage_pool_openflex_api_host")
                .info("Openflex API host name")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_OPENFLEX_API_HOST")
                .type("regex")
                .value(".+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("storage_pool_openflex_api_port")
                .info("Openflex API port")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_OPENFLEX_API_PORT")
                .type("regex")
                .value("[0-9]+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("storage_pool_openflex_job_wait_delay")
                .info("Delay in milliseconds linstor waits between fetching the job status")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_OPENFLEX_JOB_WAIT_DELAY")
                .type("regex")
                .value("[0-9]+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("storage_pool_openflex_job_wait_max_count")
                .info("Maximum retries with wait delay until openflex fails")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_OPENFLEX_JOB_WAIT_MAX_COUNT")
                .type("regex")
                .value("[0-9]+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("storage_pool_openflex_stor_dev")
                .info("Openflex storage device")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_OPENFLEX_STOR_DEV")
                .type("regex")
                .value(".+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("storage_pool_openflex_stor_dev_host")
                .info("Openflex storage device host")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_OPENFLEX_STOR_DEV_HOST")
                .type("regex")
                .value(".+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("storage_pool_openflex_stor_pool")
                .info("Openflex storage pool name")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_OPENFLEX_STOR_POOL")
                .type("regex")
                .value("[0-9]+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("storage_pool_openflex_user_name")
                .info("Openflex user name")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_OPENFLEX_USER_NAME")
                .type("regex")
                .value(".+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("storage_pool_openflex_user_pw")
                .info("Openflex password")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_OPENFLEX_USER_PW")
                .type("regex")
                .value(".+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("storage_pool_remote_spdk_api_host")
                .info("Remote SPDK API host name")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_REMOTE_SPDK_API_HOST")
                .type("regex")
                .value(".+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("storage_pool_remote_spdk_api_port")
                .info("Remote SPDK API port")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_REMOTE_SPDK_API_PORT")
                .type("regex")
                .value("[0-9]+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("storage_pool_remote_spdk_user_name")
                .info("Remote SPDK API user name")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_REMOTE_SPDK_API_USER_NAME")
                .type("regex")
                .value(".+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("storage_pool_remote_spdk_user_name_env")
                .info("Environment variable containing remote SPDK API user name")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_REMOTE_SPDK_API_USER_NAME_ENV")
                .type("regex")
                .value(".+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("storage_pool_remote_spdk_user_pw")
                .info("Remote SPDK API password")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_REMOTE_SPDK_API_USER_PW")
                .type("regex")
                .value(".+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("storage_pool_remote_spdk_user_pw_env")
                .info("Environment variable containing remote SPDK API password")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_REMOTE_SPDK_API_USER_PW_ENV")
                .type("regex")
                .value(".+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("stordriver_file_dir")
                .internal("True")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_FILE_DIRECTORY")
                .type("regex")
                .value(".*")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("stordriver_lvcreate_options")
                .info("Additional parameters added to every 'lvcreate ... ' command")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_LVCREATE_OPTIONS")
                .type("regex")
                .value(".*")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("stordriver_lvcreate_type")
                .dflt("linear")
                .internal("True")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_LVCREATE_TYPE")
                .type("symbol")
                .values(
                    "linear",
                    "lz4",
                    "lzma",
                    "mirror",
                    "raid0",
                    "raid1",
                    "raid10",
                    "raid4",
                    "raid5",
                    "raid6",
                    "striped"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("stordriver_pool_name")
                .internal("True")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_NAME")
                .type("regex")
                .value("[a-zA-Z0-9_/-]+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("stordriver_thinpool")
                .internal("True")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_THIN_POOL")
                .type("regex")
                .value("[a-zA-Z0-9_-]+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("stordriver_volumegroup")
                .internal("True")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_VOLUME_GROUP")
                .type("regex")
                .value("[a-zA-Z0-9_-]+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("stordriver_wait_timeout_after_create")
                .internal("True")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_WAIT_TIMEOUT_AFTER_CREATE")
                .type("regex")
                .value("[0-9]+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("stordriver_zfs_create_options")
                .info("Additional parameters added to every 'zfs create ... ' command")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_ZFS_CREATE_OPTIONS")
                .type("regex")
                .value(".*")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("stordriver_zpool")
                .internal("True")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_ZPOOL")
                .type("regex")
                .value("[a-zA-Z0-9_/-]+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("stordriver_zpool_thin")
                .internal("True")
                .keyRef("NAMESPC_STORAGE_DRIVER", "KEY_STOR_POOL_ZPOOLTHIN")
                .type("regex")
                .value("[a-zA-Z0-9_/-]+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("sys_fs_blkio_throttle_read")
                .info("Sets the /sys/fs/cgroup/blkio/blkio.throttle.read_bps_device")
                .internal("False")
                .keyRef("NAMESPC_SYS_FS", "KEY_SYS_FS_BLKIO_THROTTLE_READ")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("sys_fs_blkio_throttle_read_iops")
                .info("Sets the /sys/fs/cgroup/blkio/blkio.throttle.read_iops_device")
                .internal("False")
                .keyRef("NAMESPC_SYS_FS", "KEY_SYS_FS_BLKIO_THROTTLE_READ_IOPS")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("sys_fs_blkio_throttle_write")
                .info("Sets the /sys/fs/cgroup/blkio/blkio.throttle.write_bps_device")
                .internal("False")
                .keyRef("NAMESPC_SYS_FS", "KEY_SYS_FS_BLKIO_THROTTLE_WRITE")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("sys_fs_blkio_throttle_write_iops")
                .info("Sets the /sys/fs/cgroup/blkio/blkio.throttle.write_iops_device")
                .internal("False")
                .keyRef("NAMESPC_SYS_FS", "KEY_SYS_FS_BLKIO_THROTTLE_WRITE_IOPS")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("tcp-cork")
                .dflt("True")
                .internal("True")
                .keyStr("DrbdOptions/Net/tcp-cork")
                .type("boolean")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("tcp_port_range")
                .info("Range for auto-allocation of resource TCP ports")
                .keyRef("KEY_TCP_PORT_AUTO_RANGE")
                .type("regex")
                .value("[0-9]+-[0-9]+")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("timeout")
                .dflt("60")
                .internal("True")
                .keyStr("DrbdOptions/Net/timeout")
                .max("600")
                .min("1")
                .type("range")
                .unit("1/10 seconds")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("transport")
                .internal("True")
                .keyStr("DrbdOptions/Net/transport")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("twopc-retry-timeout")
                .dflt("1")
                .internal("True")
                .keyStr("DrbdOptions/Resource/twopc-retry-timeout")
                .max("50")
                .min("1")
                .type("range")
                .unit("1/10 seconds")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("twopc-timeout")
                .dflt("300")
                .internal("True")
                .keyStr("DrbdOptions/Resource/twopc-timeout")
                .max("600")
                .min("50")
                .type("range")
                .unit("1/10 seconds")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("unfence-peer")
                .internal("True")
                .keyStr("DrbdOptions/Handlers/unfence-peer")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("update_cache_interval")
                .dflt("180")
                .info("Interval for space cache background updates in seconds")
                .keyRef("KEY_UPDATE_CACHE_INTERVAL")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("use-rle")
                .dflt("True")
                .internal("True")
                .keyStr("DrbdOptions/Net/use-rle")
                .type("boolean")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("verify-alg")
                .internal("True")
                .keyStr("DrbdOptions/Net/verify-alg")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("writecache_opt_additional")
                .info("Additional arguments passed through")
                .keyRef("NAMESPC_WRITECACHE_OPTIONS", "KEY_WRITECACHE_OPTION_ADDITIONAL")
                .type("string")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("writecache_opt_autocommit_blocks")
                .dflt("64 for pmem, 65536 for ssd")
                .info("when the application writes this amount of blocks without issuing the FLUSH request, the blocks are automatically committed")
                .keyRef("NAMESPC_WRITECACHE_OPTIONS", "KEY_WRITECACHE_OPTION_AUTOCOMMIT_BLOCKS")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("writecache_opt_autocommit_time")
                .dflt("1000")
                .info("autocommit time in milliseconds. The data is automatically committed if this time passes and no FLUSH request is received")
                .keyRef("NAMESPC_WRITECACHE_OPTIONS", "KEY_WRITECACHE_OPTION_AUTOCOMMIT_TIME")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("writecache_opt_fua")
                .dflt("On")
                .info("\"On\" results in \"fua\" as argument, whereas the value \"Off\" results in \"nofua\" argument")
                .keyRef("NAMESPC_WRITECACHE_OPTIONS", "KEY_WRITECACHE_OPTION_FUA")
                .type("symbol")
                .values(
                    "Off",
                    "On"
                )
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("writecache_opt_high_watermark")
                .dflt("50")
                .info("start writeback when the number of used blocks reach this watermark")
                .keyRef("NAMESPC_WRITECACHE_OPTIONS", "KEY_WRITECACHE_OPTION_HIGH_WATERMARK")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("writecache_opt_low_watermark")
                .dflt("45")
                .info("stop writeback when the number of used blocks drops below this watermark")
                .keyRef("NAMESPC_WRITECACHE_OPTIONS", "KEY_WRITECACHE_OPTION_LOW_WATERMARK")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("writecache_opt_start_sector")
                .dflt("0")
                .info("offset from the start of cache device in 512-byte sectors")
                .keyRef("NAMESPC_WRITECACHE_OPTIONS", "KEY_WRITECACHE_OPTION_START_SECTOR")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("writecache_opt_writeback_jobs")
                .dflt("unlimited")
                .info("limit the number of blocks that are in flight during writeback. Setting this value reduces writeback throughput, but it may improve latency of read requests")
                .keyRef("NAMESPC_WRITECACHE_OPTIONS", "KEY_WRITECACHE_OPTION_WRITEBACK_JOBS")
                .type("long")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("writecache_pool_name")
                .info("Linstor storage pool name for writecache")
                .keyRef("NAMESPC_WRITECACHE", "KEY_WRITECACHE_POOL_NAME")
                .type("regex")
                .value("^[a-zA-Z0-9_][a-zA-Z0-9_-]{2,47}$")
                .build()
        );
        propertyList.add(
            new PropertyBuilder()
                .name("writecache_size")
                .info("Size of the writecache in % (0-100) or KiB otherwise")
                .keyRef("NAMESPC_WRITECACHE", "KEY_WRITECACHE_SIZE")
                .type("regex")
                .value("^100%|[0-9]{1,2}([.][0-9]*)?%|[1-9][0-9]{2,}$")
                .build()
        );
        return propertyList;
    }
    public static Map<LinStorObject, List<String>> getWhitelistedRules()
    {
        Map<LinStorObject, List<String>> rules = new TreeMap<>();
        rules.put(LinStorObject.CONTROLLER,
            Arrays.asList(
                "after-resync-target",
                "after-sb-0pri",
                "after-sb-1pri",
                "after-sb-2pri",
                "al-extents",
                "al-updates",
                "allow-remote-read",
                "allow-two-primaries",
                "always-asbp",
                "auto-promote",
                "auto-promote-timeout",
                "auto_evict_after_time",
                "auto_evict_allow_eviction",
                "auto_evict_max_disconnected_nodes",
                "auto_evict_min_replica_count",
                "autoplacer_max_throughput",
                "autoplacer_pre_select_script_filename",
                "autoplacer_pre_select_script_timeout",
                "autoplacer_strat_weights_max_freespace",
                "autoplacer_strat_weights_max_throughput",
                "autoplacer_strat_weights_min_reserved_space",
                "autoplacer_strat_weights_min_rsc_count",
                "backup_shipping_s3_key_suffix",
                "backup_shipping_timeout",
                "bcache_block_size",
                "bcache_bucket_size",
                "bcache_cache_replacement_policy",
                "bcache_data_offset",
                "bcache_discard",
                "bcache_pool",
                "bcache_size",
                "bcache_writeback",
                "before-resync-source",
                "before-resync-target",
                "bitmap",
                "c-delay-target",
                "c-fill-target",
                "c-max-rate",
                "c-min-rate",
                "c-plan-ahead",
                "cache_blocksize",
                "cache_cache_pool",
                "cache_cache_size",
                "cache_meta_pool",
                "cache_meta_size",
                "cache_op_mode",
                "cache_policy",
                "congestion-extents",
                "congestion-fill",
                "connect-int",
                "cpu-mask",
                "cram-hmac-alg",
                "csums-after-crash-only",
                "csums-alg",
                "data-integrity-alg",
                "disable-write-same",
                "discard-zeroes-if-aligned",
                "disk-barrier",
                "disk-drain",
                "disk-flushes",
                "disk-timeout",
                "dm_stats",
                "drbd_auto_add_quorum_tie_breaker",
                "drbd_auto_diskful",
                "drbd_auto_diskful_allow_cleanup",
                "drbd_auto_quorum",
                "drbd_auto_verify_algo_allowed_user",
                "drbd_auto_verify_algo_disable",
                "ext_cmd_wait_to",
                "fence-peer",
                "fencing",
                "initial-split-brain",
                "ko-count",
                "local-io-error",
                "max-buffers",
                "max-epoch-size",
                "max-io-depth",
                "md-flushes",
                "minor_nr_range",
                "nvme_port",
                "nvme_preferred_nic",
                "nvme_tr_type",
                "on-congestion",
                "on-io-error",
                "on-no-data-accessible",
                "on-no-quorum",
                "out-of-sync",
                "peer-ack-delay",
                "peer-ack-window",
                "peer_slots_new_resource",
                "ping-int",
                "ping-timeout",
                "pri-lost",
                "pri-lost-after-sb",
                "pri-on-incon-degr",
                "protocol",
                "proxy_auto_enable",
                "quorum",
                "quorum-lost",
                "quorum-minimum-redundancy",
                "rcvbuf-size",
                "read-balancing",
                "rest_disable_http_metrics",
                "resync-after",
                "resync-rate",
                "rr-conflict",
                "rs-discard-granularity",
                "search_domain",
                "shared-secret",
                "site",
                "snapshot_shipping_port_range",
                "sndbuf-size",
                "socket-check-timeout",
                "split-brain",
                "storage_pool_exos_create_vlm_options",
                "storage_pool_exos_vlm_type",
                "storage_pool_openflex_api_host",
                "storage_pool_openflex_api_port",
                "storage_pool_openflex_job_wait_delay",
                "storage_pool_openflex_job_wait_max_count",
                "storage_pool_openflex_user_name",
                "storage_pool_openflex_user_pw",
                "storage_pool_remote_spdk_api_host",
                "storage_pool_remote_spdk_api_port",
                "storage_pool_remote_spdk_user_name",
                "storage_pool_remote_spdk_user_name_env",
                "storage_pool_remote_spdk_user_pw",
                "storage_pool_remote_spdk_user_pw_env",
                "stordriver_lvcreate_options",
                "stordriver_wait_timeout_after_create",
                "stordriver_zfs_create_options",
                "sys_fs_blkio_throttle_read",
                "sys_fs_blkio_throttle_read_iops",
                "sys_fs_blkio_throttle_write",
                "sys_fs_blkio_throttle_write_iops",
                "tcp-cork",
                "tcp_port_range",
                "timeout",
                "transport",
                "twopc-retry-timeout",
                "twopc-timeout",
                "unfence-peer",
                "update_cache_interval",
                "use-rle",
                "verify-alg",
                "writecache_opt_additional",
                "writecache_opt_autocommit_blocks",
                "writecache_opt_autocommit_time",
                "writecache_opt_fua",
                "writecache_opt_high_watermark",
                "writecache_opt_low_watermark",
                "writecache_opt_start_sector",
                "writecache_opt_writeback_jobs",
                "writecache_pool_name",
                "writecache_size"
            )
        );
        rules.put(LinStorObject.DRBD_PROXY,
            Arrays.asList(
                "proxy_memlimit",
                "proxy_ping_timeout",
                "proxy_rcvbuf_size",
                "proxy_read_loops",
                "proxy_sndbuf_size"
            )
        );
        rules.put(LinStorObject.DRBD_PROXY_LZMA,
            Arrays.asList(
                "proxy_compression_lzma_contexts",
                "proxy_compression_lzma_depth",
                "proxy_compression_lzma_dict_size",
                "proxy_compression_lzma_fallback_to_zlib",
                "proxy_compression_lzma_lc",
                "proxy_compression_lzma_level",
                "proxy_compression_lzma_lp",
                "proxy_compression_lzma_mf",
                "proxy_compression_lzma_mode",
                "proxy_compression_lzma_nice_len",
                "proxy_compression_lzma_numa_threshold",
                "proxy_compression_lzma_pb"
            )
        );
        rules.put(LinStorObject.DRBD_PROXY_ZLIB,
            Arrays.asList(
                "proxy_compression_zlib_level"
            )
        );
        rules.put(LinStorObject.DRBD_PROXY_ZSTD,
            Arrays.asList(
                "proxy_compression_zstd_level"
            )
        );
        rules.put(LinStorObject.NODE,
            Arrays.asList(
                "auto_evict_after_time",
                "auto_evict_allow_eviction",
                "autoplacer_max_throughput",
                "bcache_block_size",
                "bcache_bucket_size",
                "bcache_cache_replacement_policy",
                "bcache_data_offset",
                "bcache_discard",
                "bcache_pool",
                "bcache_size",
                "bcache_writeback",
                "cache_blocksize",
                "cache_cache_pool",
                "cache_cache_size",
                "cache_meta_pool",
                "cache_meta_size",
                "cache_op_mode",
                "cache_policy",
                "drbd_auto_diskful_allow_cleanup",
                "preferred_nic",
                "proxy_auto_enable",
                "site",
                "storage_pool_drbd_meta_name",
                "storage_pool_exos_create_vlm_options",
                "storage_pool_exos_vlm_type",
                "storage_pool_name",
                "storage_pool_openflex_api_host",
                "storage_pool_openflex_api_port",
                "storage_pool_openflex_job_wait_delay",
                "storage_pool_openflex_job_wait_max_count",
                "storage_pool_openflex_stor_dev",
                "storage_pool_openflex_stor_dev_host",
                "storage_pool_openflex_user_name",
                "storage_pool_openflex_user_pw",
                "storage_pool_remote_spdk_api_host",
                "storage_pool_remote_spdk_api_port",
                "storage_pool_remote_spdk_user_name",
                "storage_pool_remote_spdk_user_name_env",
                "storage_pool_remote_spdk_user_pw",
                "storage_pool_remote_spdk_user_pw_env",
                "stordriver_lvcreate_options",
                "stordriver_zfs_create_options",
                "sys_fs_blkio_throttle_read",
                "sys_fs_blkio_throttle_read_iops",
                "sys_fs_blkio_throttle_write",
                "sys_fs_blkio_throttle_write_iops",
                "writecache_opt_additional",
                "writecache_opt_autocommit_blocks",
                "writecache_opt_autocommit_time",
                "writecache_opt_fua",
                "writecache_opt_high_watermark",
                "writecache_opt_low_watermark",
                "writecache_opt_start_sector",
                "writecache_opt_writeback_jobs",
                "writecache_pool_name",
                "writecache_size"
            )
        );
        rules.put(LinStorObject.RESOURCE,
            Arrays.asList(
                "drbd_auto_diskful_allow_cleanup",
                "fs_mkfsparameters",
                "fs_type",
                "nvme_preferred_nic",
                "peer_slots",
                "preferred_nic",
                "storage_pool_drbd_meta_name",
                "storage_pool_exos_create_vlm_options",
                "storage_pool_name",
                "sys_fs_blkio_throttle_read",
                "sys_fs_blkio_throttle_read_iops",
                "sys_fs_blkio_throttle_write",
                "sys_fs_blkio_throttle_write_iops"
            )
        );
        rules.put(LinStorObject.RESOURCE_DEFINITION,
            Arrays.asList(
                "after-resync-target",
                "after-sb-0pri",
                "after-sb-1pri",
                "after-sb-2pri",
                "al-extents",
                "al-updates",
                "allow-remote-read",
                "allow-two-primaries",
                "always-asbp",
                "auto-promote",
                "auto-promote-timeout",
                "auto_evict_min_replica_count",
                "auto_snapshot_keep",
                "auto_snapshot_next_id",
                "auto_snapshot_run_every",
                "bcache_block_size",
                "bcache_bucket_size",
                "bcache_cache_replacement_policy",
                "bcache_data_offset",
                "bcache_discard",
                "bcache_pool",
                "bcache_size",
                "bcache_writeback",
                "before-resync-source",
                "before-resync-target",
                "bitmap",
                "c-delay-target",
                "c-fill-target",
                "c-max-rate",
                "c-min-rate",
                "c-plan-ahead",
                "cache_blocksize",
                "cache_cache_pool",
                "cache_cache_size",
                "cache_meta_pool",
                "cache_meta_size",
                "cache_op_mode",
                "cache_policy",
                "congestion-extents",
                "congestion-fill",
                "connect-int",
                "cpu-mask",
                "cram-hmac-alg",
                "csums-after-crash-only",
                "csums-alg",
                "data-integrity-alg",
                "disable-write-same",
                "discard-zeroes-if-aligned",
                "disk-barrier",
                "disk-drain",
                "disk-flushes",
                "disk-timeout",
                "drbd_auto_add_quorum_tie_breaker",
                "drbd_auto_diskful",
                "drbd_auto_diskful_allow_cleanup",
                "drbd_auto_quorum",
                "drbd_auto_verify_algo_disable",
                "fence-peer",
                "fencing",
                "fs_mkfsparameters",
                "fs_type",
                "initial-split-brain",
                "ko-count",
                "local-io-error",
                "max-buffers",
                "max-epoch-size",
                "max-io-depth",
                "md-flushes",
                "nvme_port",
                "nvme_tr_type",
                "on-congestion",
                "on-io-error",
                "on-no-data-accessible",
                "on-no-quorum",
                "out-of-sync",
                "peer-ack-delay",
                "peer-ack-window",
                "peer_slots_new_resource",
                "ping-int",
                "ping-timeout",
                "preferred_nic",
                "pri-lost",
                "pri-lost-after-sb",
                "pri-on-incon-degr",
                "protocol",
                "proxy_compression_type",
                "quorum",
                "quorum-lost",
                "quorum-minimum-redundancy",
                "rcvbuf-size",
                "read-balancing",
                "resync-after",
                "resync-rate",
                "rr-conflict",
                "rs-discard-granularity",
                "shared-secret",
                "snapshot_shipping_keep",
                "snapshot_shipping_run_every",
                "snapshot_shipping_source",
                "snapshot_shipping_target",
                "sndbuf-size",
                "socket-check-timeout",
                "split-brain",
                "storage_pool_drbd_meta_name",
                "storage_pool_exos_create_vlm_options",
                "storage_pool_exos_vlm_type",
                "storage_pool_name",
                "stordriver_lvcreate_options",
                "stordriver_lvcreate_type",
                "stordriver_zfs_create_options",
                "sys_fs_blkio_throttle_read",
                "sys_fs_blkio_throttle_read_iops",
                "sys_fs_blkio_throttle_write",
                "sys_fs_blkio_throttle_write_iops",
                "tcp-cork",
                "timeout",
                "transport",
                "twopc-retry-timeout",
                "twopc-timeout",
                "unfence-peer",
                "use-rle",
                "verify-alg",
                "writecache_opt_additional",
                "writecache_opt_autocommit_blocks",
                "writecache_opt_autocommit_time",
                "writecache_opt_fua",
                "writecache_opt_high_watermark",
                "writecache_opt_low_watermark",
                "writecache_opt_start_sector",
                "writecache_opt_writeback_jobs",
                "writecache_pool_name",
                "writecache_size"
            )
        );
        rules.put(LinStorObject.RSC_CONN,
            Arrays.asList(
                "after-sb-0pri",
                "after-sb-1pri",
                "after-sb-2pri",
                "allow-remote-read",
                "allow-two-primaries",
                "always-asbp",
                "bitmap",
                "c-delay-target",
                "c-fill-target",
                "c-max-rate",
                "c-min-rate",
                "c-plan-ahead",
                "congestion-extents",
                "congestion-fill",
                "connect-int",
                "cram-hmac-alg",
                "csums-after-crash-only",
                "csums-alg",
                "data-integrity-alg",
                "fencing",
                "ko-count",
                "max-buffers",
                "max-epoch-size",
                "on-congestion",
                "ping-int",
                "ping-timeout",
                "protocol",
                "rcvbuf-size",
                "resync-rate",
                "rr-conflict",
                "shared-secret",
                "sndbuf-size",
                "socket-check-timeout",
                "tcp-cork",
                "timeout",
                "transport",
                "use-rle",
                "verify-alg"
            )
        );
        rules.put(LinStorObject.STORAGEPOOL,
            Arrays.asList(
                "autoplacer_max_throughput",
                "nvme_preferred_nic",
                "preferred_nic",
                "storage_pool_exos_create_vlm_options",
                "storage_pool_exos_enclosure",
                "storage_pool_exos_pool_sn",
                "storage_pool_exos_vlm_type",
                "storage_pool_openflex_api_host",
                "storage_pool_openflex_api_port",
                "storage_pool_openflex_stor_dev",
                "storage_pool_openflex_stor_dev_host",
                "storage_pool_openflex_stor_pool",
                "storage_pool_openflex_user_name",
                "storage_pool_openflex_user_pw",
                "storage_pool_remote_spdk_api_host",
                "storage_pool_remote_spdk_api_port",
                "storage_pool_remote_spdk_user_name",
                "storage_pool_remote_spdk_user_name_env",
                "storage_pool_remote_spdk_user_pw",
                "storage_pool_remote_spdk_user_pw_env",
                "stordriver_file_dir",
                "stordriver_lvcreate_options",
                "stordriver_lvcreate_type",
                "stordriver_pool_name",
                "stordriver_thinpool",
                "stordriver_volumegroup",
                "stordriver_wait_timeout_after_create",
                "stordriver_zfs_create_options",
                "stordriver_zpool",
                "stordriver_zpool_thin",
                "sys_fs_blkio_throttle_read",
                "sys_fs_blkio_throttle_read_iops",
                "sys_fs_blkio_throttle_write",
                "sys_fs_blkio_throttle_write_iops"
            )
        );
        rules.put(LinStorObject.STORAGEPOOL_DEFINITION,
            Arrays.asList(
                "max_oversubscription_ratio",
                "sys_fs_blkio_throttle_read",
                "sys_fs_blkio_throttle_read_iops",
                "sys_fs_blkio_throttle_write",
                "sys_fs_blkio_throttle_write_iops"
            )
        );
        rules.put(LinStorObject.VOLUME,
            Arrays.asList(
                "storage_pool_drbd_meta_name",
                "storage_pool_name",
                "sys_fs_blkio_throttle_read",
                "sys_fs_blkio_throttle_read_iops",
                "sys_fs_blkio_throttle_write",
                "sys_fs_blkio_throttle_write_iops"
            )
        );
        rules.put(LinStorObject.VOLUME_DEFINITION,
            Arrays.asList(
                "al-extents",
                "al-updates",
                "bcache_block_size",
                "bcache_bucket_size",
                "bcache_cache_replacement_policy",
                "bcache_data_offset",
                "bcache_discard",
                "bcache_pool",
                "bcache_size",
                "bcache_writeback",
                "cache_blocksize",
                "cache_cache_pool",
                "cache_cache_size",
                "cache_meta_pool",
                "cache_meta_size",
                "cache_op_mode",
                "cache_policy",
                "disable-write-same",
                "discard-zeroes-if-aligned",
                "disk-barrier",
                "disk-drain",
                "disk-flushes",
                "disk-timeout",
                "drbd_current_gi",
                "fs_mkfsparameters",
                "fs_type",
                "md-flushes",
                "on-io-error",
                "override_vlm_id",
                "read-balancing",
                "resync-after",
                "rs-discard-granularity",
                "storage_pool_drbd_meta_name",
                "storage_pool_exos_create_vlm_options",
                "storage_pool_exos_vlm_type",
                "storage_pool_name",
                "stordriver_lvcreate_options",
                "stordriver_lvcreate_type",
                "stordriver_zfs_create_options",
                "sys_fs_blkio_throttle_read",
                "sys_fs_blkio_throttle_read_iops",
                "sys_fs_blkio_throttle_write",
                "sys_fs_blkio_throttle_write_iops",
                "writecache_opt_additional",
                "writecache_opt_autocommit_blocks",
                "writecache_opt_autocommit_time",
                "writecache_opt_fua",
                "writecache_opt_high_watermark",
                "writecache_opt_low_watermark",
                "writecache_opt_start_sector",
                "writecache_opt_writeback_jobs",
                "writecache_pool_name",
                "writecache_size"
            )
        );
        return rules;
    }
}
